--require('main')

class "Boss1"{
	name = "Boss1";
	id=0;
	x=0;
	y=0;
	hspeed=0;
	vspeed=0;
	animation="";
	animations={{GFX.newImage("boss1_walk1.png"),36,41,0.1,2}};
	img_speed=0;
	img_frame=1;
	img_alpha=255;
    last_frame=1;
    blend_mode='';
	FRAMES=0;
	body=0;
    HITBOXES={love.physics.newPolygonShape(400,300,436,300,436,341,400,341),love.physics.newPolygonShape(400,300,436,300,436,341,400,341)};
    draw_hitbox=false;
    density=0;
    colliding='';
	anim=nil;--newAnimation();
}

function Boss1:destroy()
	id = self.id
	for k,d in ipairs(objects) do
		if d.id == id then
			table.remove(objects,k)
		end
	end
end



function Boss1:__init(...)
	self.x = arg[1] or 0
	self.y = arg[2] or 0
    table.remove(arg,1)
    table.remove(arg,2)
    self.args = {}
    for i,v in ipairs(arg) do
        table.insert(self.args,v)
    end
    self.body=love.physics.newBody(phys_world,0,0,"dynamic")
    self.fixture=love.physics.newFixture(self.body,self.HITBOXES[1],self.density);
    self.id=math.random(1,10000000);
	

    udata = {}
    udata['name']=self.name
    udata['id']=self.id
    --udata = setmetatable(udata,{name=self.name;id=self.id})

    self.fixture:setUserData(udata)

self.animation="boss1_walk1.png"
self.FRAMES=2
self.anim=newAnimation(GFX.newImage("boss1_walk1.png"),36,41,0.1,2)
self.img_speed=0.1
GFX.setBackgroundColor("pink")
self.dspeed = 2
self.hitbox_visible = true
addObj(self)

end

function Boss1:update(dt)
	self.x = self.x + self.hspeed
	self.y = self.y + self.vspeed
	if self.anim ~= nil then
		self.anim:setSpeed(self.img_speed)
	    if self.last_frame ~= self.img_frame then
	          self.fixture.destroy()
	          self.fixture=love.physics.newFixture(self.body,self.HITBOXES[self.img_frame],self.density)
	    end
		if self.img_speed == 0 then
			if self.img_frame <= 0 then
				self.img_frame = self.FRAMES
			elseif self.img_frame > self.FRAMES then
				self.img_frame = 1
			end
			self.anim:seek(self.img_frame)
		else
	        self.img_frame = self.anim.position
	    end
	    self.body:setPosition(self.x,self.y)
	    self.last_frame = self.img_frame
		self.anim:update(dt)
	end

if KEY.check('left') then
	self.x = self.x - self.dspeed
end
if KEY.check('right') then
	self.x = self.x + self.dspeed
end
if KEY.check('up') then
	self.y = self.y - self.dspeed
end

if KEY.check('down') then
	self.y = self.y + self.dspeed
end
end

function Boss1:draw()
	if self.anim ~= nil then
		love.graphics.setColor(255,255,255,255)
	    if table.contains(BLEND_MODES,self.blend_mode) then
	        love.graphics.setBlendMode(self.blend_mode)
	    end
		self.anim:draw(self.x,self.y)
		if self.draw_hitbox then
	    	love.graphics.polygon("fill",self.body:getWorldPoints(self.HITBOXES[self.img_frame]:getPoints()))
		end
	end


end

function Boss1:keyrelease(key)
if key == 'f' then
	for i,v in ipairs(objects) do
		DBG.print(v.name..':'..v.id)
	end
end
end

function Boss1:keypress(key)

end

function Boss1:collision(other)
	self.colliding = other.name
DBG.print('colliding '..self.colliding..':'..other.id..' image '..self.img_frame)
end

function Boss1:collisionEnd(other)
	self.colliding = ''
DBG.print('not colliding '..self.colliding..' image '..self.img_frame)
end

