--object arrays
objects = {}

--API
--GFX = GFX:new()

--global game vars
paused = false
fullscreen = false

phys_world = love.physics.newWorld(0,1, true)

BLEND_MODES = {'additive','alpha','subtractive','multiplicative','premultiplied'}
COLORS = {
["white"]={255,255,255},
["black"]={0,0,0},
["pink"]= {255,192,203}
}

function notNil(var)
	if var == nil then return false
	else return true end
end

--global game functions
function gameInitialize()
--	iniData = inifile.parse("settings.ini")
end

function table.contains(table, element)
  for _, value in pairs(table) do
    if value == element then
      return true
    end
  end
  return false
end

function addObj(obj)
	obj["in_view"] = obj["in_view"] or true
	obj["depth"] = obj["depth"] or 0

	objects[#objects+1] = obj

	--[[
	function comp(a,b)
		return a["depth"] > b["depth"]
	end
	table.sort(objects,comp)
	]]--

	if obj.name == "Trail" or obj.name == "IntroTrail" then else
		io.write("[","?","] adding ",obj.name," (",obj.x,",",obj.y,"):",obj.id," d",obj.depth,"\n")
	end
end

function showDebug() --show mouse coordinates,..
	love.graphics.print("Mouse X: "..love.mouse.getX().." Mouse Y: "..love.mouse.getY(),10,20)
end

function precision(value,digits) --decimal places
	shift = 10 ^ digits
	result = math.floor(value*shift + 0.5 ) / shift
	return result
end

function pixelEffect()
	effect = love.graphics.newPixelEffect[[
		extern number value;
		vec4 effect(vec4 color, Image texture,vec2 texture_coords, vec2 pixel_coords)
		{
			vec4 pixel = Texel(texture,texture_coords);
			float avg = max(0,((pixel.r+pixel.g+pixel.b)/3)+value/10);
			pixel.r = avg
			pixel.g = avg
			pixel.b = avg
			return pixel;
		}
	]]
	effect:send("value",value)
	love.graphics.setPixelEffect(effect)
	love.graphics.setColor(255,255,255)
end
