require('requires')

game_state = 0
stateName=''

backgroundColor = {255,255,255,255}

function love.load()
	--love.physics.setMeter(64)
    phys_world:setCallbacks(beginContact, endContact, preSolve, postSolve)
    persisting = 0
	loadstring('state0start()')()
end

function love.update(dt)
	love.timer.sleep(.001)
	for k,d in ipairs(objects) do
		if notNil(d.update) then
			d:update(dt)
		end
	end
	phys_world:update(dt)
	--main_update()
end

function love.draw(dt)
	for k,d in ipairs(objects) do
		love.graphics.reset()
		love.graphics.setBackgroundColor(backgroundColor)
		if DBG.visible then DBG:draw() end
		if notNil(d.draw) then
				d:draw()
		end
	end
	--main_draw()
end

function love.keypressed(key)
	--if key == "p" then --toggle pause
	--	paused = not paused
	--	print("paused: ",paused)
	--end
	if key == "f11" then
		love.graphics.toggleFullscreen()
		fullscreen = not fullscreen
		--iniWrite("fullscreen",tostring(fullscreen))
	end
	if key == "escape" then
		love.event.quit()
	end
	for k,d in ipairs(objects) do
		if notNil(d.keypress) then
			d:keypress(key)
		end
	end
end

function love.keyreleased(key)
	--if key == "p" then --toggle pause
	--	paused = not paused
	--	print("paused: ",paused)
	--end
	for k,d in ipairs(objects) do
		if notNil(d.keyrelease) then
			d:keyrelease(key)
		end
	end
end

function love.conf(t)
    t.screen.vsync = false
end

function love.quit()

end

-- Collision functions
function beginContact(a, b, coll)
    x,y = coll:getNormal()
    a = a:getUserData()
    b = b:getUserData()
    v1 = ''
    v2 = ''
    for i,v in ipairs(objects) do
    	if v.id == a['id'] then v1 = v end
    	if v.id == b['id'] then v2 = v end
    end
    v1:collision(v2)
    v2:collision(v1)
    --DBG.print(a['name'].." colliding with "..b['name'].." with a vector normal of: "..x..", "..y)
end

function endContact(a, b, coll)
    a = a:getUserData()
    b = b:getUserData()
    v1 = nil
    v2 = nil
    for i,v in ipairs(objects) do
    	if v.id == a['id'] then v1 = v end
    	if v.id == b['id'] then v2 = v end
    end
    v1:collisionEnd(v2)
    v2:collisionEnd(v1)
    --DBG.print(a['name'].." uncolliding with "..b['name'])
end

function preSolve(a, b, coll)
end

function postSolve(a, b, coll)
end
------------------------------------------------------------------------------------------------------------------------------
